<?php

/******************************************************************************/
/******************************************************************************/

class NPPlugin
{
	/**************************************************************************/
	
	var $option;
	var $nextPost;
	var $prevPost;
	var $currentPostId;
	var $currentPostType;
	var $currentPostCategory;
	
	/**************************************************************************/
	
	var $adminScript=array
	(
		'jquery'=>array(null),
		'jquery-ui-core'=>array(null),
		'jquery-ui-slider'=>array(null),
		'jquery-ui-button'=>array(null),
		'jquery-ui-tabs'=>array(null),
		'jquery-qtip'=>array('jquery.qtip.min.js'),
		'jquery-blockUI'=>array('jquery.blockUI.js'),
		'jquery-dropkick'=>array('jquery.dropkick.min.js'),
		'jquery-colorpicker'=>array('jquery.colorpicker.js'),
		'jquery-infieldlabel'=>array('jquery.infieldlabel.min.js'),
		'jquery-themeOption'=>array('jquery.themeOption.js'),
		'jquery-themeOptionElement'=>array('jquery.themeOptionElement.js')
	);
	
	/**************************************************************************/
	
	var $adminStyle=array
	(
		'jquery-ui'=>array('jquery.ui.min.css'),
		'jquery-qtip'=>array('jquery.qtip.min.css'),
		'jquery-dropkick'=>array('jquery.dropkick.css'),
		'jquery-colorpicker'=>array('jquery.colorpicker.css'),
		'jquery-themeOption'=>array('jquery.themeOption.css'),
		'jquery-themeOption-overwrite-np'=>array('jquery.themeOption.overwrite.css'),
		'gf-open-sans'=>array()
	);
	
	/**************************************************************************/
	
	var $publicScript=array
	(
		'jquery'=>array(null),
		'jquery-easing'=>array('jquery.easing.js'),
		'next-post'=>array('jquery.nextPost.js')
	);
	
	/**************************************************************************/
	
	var $publicStyle=array
	(
		'next-post'=>array('next-post-public.css'),
		'next-post-responsive'=>array('next-post-public-responsive.css')
	);
	
	/**************************************************************************/
	
	var $easingType=array
	(
		'easeInQuad',
		'easeOutQuad',
		'easeInOutQuad',
		'easeInCubic',
		'easeOutCubic',
		'easeInOutCubic',
		'easeInQuart',
		'easeOutQuart',
		'easeInOutQuart',
		'easeInOutQuart',
		'easeInQuint',
		'easeOutQuint',
		'easeInOutQuint',
		'easeInSine',
		'easeOutSine',
		'easeInOutSine',
		'easeInExpo',
		'easeOutExpo',
		'easeInOutExpo',
		'easeInCirc',
		'easeOutCirc',
		'easeInOutCirc',
		'easeInElastic',
		'easeOutElastic',
		'easeInOutElastic',
		'easeInBack',
		'easeOutBack',
		'easeInOutBack',
		'easeInBounce',
		'easeOutBounce',
		'easeInOutBounce'
	);
	
	/**************************************************************************/
	
	var $animationType=array
	(
		'slide',
		'fade'		
	);
	
	/**************************************************************************/

	var $optionDefault=array
	(
		PLUGIN_NEXT_POST_OPTION_GENERAL=>array
		(
			'enable'=>'1',
			'sort_type'=>'post_date',
			'sort_direction'=>'desc',
			'responsive_enable'=>'1',
			'load_event_enable'=>'0',
			'style_box_padding_top'=>'25',
			'style_box_padding_right'=>'25',
			'style_box_padding_bottom'=>'25',
			'style_box_padding_left'=>'25',
			'style_box_border_top_color'=>'49A7ED',
			'style_box_border_right_color'=>'',
			'style_box_border_bottom_color'=>'',
			'style_box_border_left_color'=>'',
			'style_box_border_top_width'=>'5',
			'style_box_border_right_width'=>'0',
			'style_box_border_bottom_width'=>'0',
			'style_box_border_left_width'=>'0',
			'style_header_font_family'=>'\'Tahoma\'',
			'style_header_font_size'=>'18',
			'style_header_font_color'=>'CCCCCC',
			'style_title_font_family'=>'\'Tahoma\'',
			'style_title_font_size'=>'16',
			'style_title_font_color'=>'0066CC',
			'style_content_font_family'=>'\'Tahoma\'',
			'style_content_font_size'=>'13',
			'style_content_font_color'=>'888888',
		),
		PLUGIN_NEXT_POST_OPTION_NEXT_POST=>array
		(
			'enable'=>'1',
			'offset'=>'80',
			'offset_element'=>'',
			'position_value'=>'0',
			'position_type'=>'bottom',
			'box_width'=>'500',
			'image_size_width'=>'90',
			'image_size_height'=>'90',
			'animation_type'=>'slide',
			'animation_open_easing'=>'easeInOutSine',
			'animation_open_speed'=>'300',
			'animation_close_easing'=>'easeInExpo',
			'animation_close_speed'=>'200',
			'display_image'=>'1',
			'display_title'=>'1',
			'display_excerpt'=>'1',
			'display_content'=>'1',
			'display_close_button'=>'1',
			'header_text'=>'Read next article ...',
			'post_excerpt_no_limit'=>'1',
			'post_excerpt_limit_value'=>'0',
			'category'=>array(0),
			'custom_post_type'=>array('post'),
			'responsive_width_enable'=>'0',
			'responsive_width_value'=>'',
			'responsive_height_enable'=>'0',
			'responsive_height_value'=>''			
		),
		PLUGIN_NEXT_POST_OPTION_PREV_POST=>array
		(
			'enable'=>'1',
			'offset'=>'80',
			'offset_element'=>'',
			'position_value'=>'0',
			'position_type'=>'bottom',
			'box_width'=>'500',
			'image_size_width'=>'90',
			'image_size_height'=>'90',
			'animation_type'=>'slide',
			'animation_open_easing'=>'easeInOutSine',
			'animation_open_speed'=>'300',
			'animation_close_easing'=>'easeInExpo',
			'animation_close_speed'=>'200',
			'display_image'=>'1',
			'display_title'=>'1',
			'display_excerpt'=>'1',
			'display_content'=>'1',
			'display_close_button'=>'1',
			'header_text'=>'Read previous article ...',
			'post_excerpt_no_limit'=>'1',
			'post_excerpt_limit_value'=>'0',
			'category'=>array(0),
			'custom_post_type'=>array('post'),
			'responsive_width_enable'=>'0',
			'responsive_width_value'=>'',
			'responsive_height_enable'=>'0',
			'responsive_height_value'=>''			
		)	
	);
	
	/**************************************************************************/
	/**************************************************************************/
	
	function __construct()
	{
		$this->sortType=array
		(
			'ID'=>__('Post ID','next-post'),
			'post_date'=>__('Post create date','next-post'),
			'modified'=>__('Post last modified date','next-post')
		);

		$this->sortDirection=array
		(
			'asc'=>__('Ascending','next-post'),
			'desc'=>__('Descending','next-post')
		);
		
		$this->currentPostId=0;
		$this->option=get_option(PLUGIN_NEXT_POST_CONTEXT);
	}
	
	/**************************************************************************/
	
	function adminInit()
	{
		$this->adminStyle['gf-open-sans']=array(add_query_arg(array('family'=>urlencode('Open Sans:300,300i,400,400i,600,600i,700,700i,800,800i'),'subset'=>'cyrillic,cyrillic-ext,greek,greek-ext,latin-ext,vietnamese'),'//fonts.googleapis.com/css'));
		
		foreach($this->adminStyle as $index=>$data)	wp_register_style($index,$this->getLibraryPath(PLUGIN_NEXT_POST_STYLE_URL,$data[0]));
		foreach($this->adminScript as $index=>$data) wp_register_script($index,$this->getLibraryPath(PLUGIN_NEXT_POST_SCRIPT_URL,$data[0]));
	}
	
	/**************************************************************************/
	
	function adminPrintLibrary()
	{
		foreach($this->adminStyle as $index=>$data) wp_enqueue_style($index);
		foreach($this->adminScript as $index=>$data) wp_enqueue_script($index);	
		
		wp_deregister_script('wp-color-picker');
		wp_dequeue_script('wp-color-picker');
	}
	
	/**************************************************************************/

	function publicEnqueueScript()
	{
		if($this->getGeneralOption('responsive_enable')!=1)
			unset($this->publicStyle['next-post-public-responsive-style']);
			
		foreach($this->publicStyle as $index=>$value) wp_enqueue_style($index,$this->getLibraryPath(PLUGIN_NEXT_POST_STYLE_URL,$value[0]));
		foreach($this->publicScript as $index=>$value) wp_enqueue_script($index,$this->getLibraryPath(PLUGIN_NEXT_POST_SCRIPT_URL,$value[0]));
	}
	
	/**************************************************************************/	
	
	function pluginActivation()
	{
		$optionPrevious=get_option('next_post_option');
		if($optionPrevious!==false)
		{
			$optionCurrent=array();
			
			foreach($optionPrevious as $optionPreviousIndex=>$optionPreviousValue)
			{
				$optionCurrentIndex=preg_replace('/^next_post_option_/',PLUGIN_NEXT_POST_CONTEXT.'_',$optionPreviousIndex);
				$optionCurrent[$optionCurrentIndex]=$optionPreviousValue;
			}
			
			update_option(PLUGIN_NEXT_POST_CONTEXT,$optionCurrent);
			delete_option('next_post_option');
		}
		
		/***/
		
		$optionDefault=$this->getFlatOptionArray();
		$optionSave=(array)get_option(PLUGIN_NEXT_POST_CONTEXT);

		foreach($optionDefault as $optionDefaultIndex=>$optionDefaultValue)
		{
			if(!array_key_exists($optionDefaultIndex,$optionSave))
				$optionSave[$optionDefaultIndex]=$optionDefaultValue;			
		}
		
		update_option(PLUGIN_NEXT_POST_CONTEXT,$optionSave);
	}
	
	/**************************************************************************/

	function adminInitMenu()
	{
		$page=add_options_page(__('Next Post Fly Box','next-post'),__('Next Post Fly Box','next-post'),'administrator','next_post_admin',array($this,'adminInitOptionPage'));
		add_action('admin_print_scripts-'.$page,array($this,'adminPrintLibrary'));		
	}
	
	/**************************************************************************/
	
	function adminInitOptionPage()
	{
		$data=array();
		
		$this->option=get_option(PLUGIN_NEXT_POST_CONTEXT);

		$data['option']=$this->option;
		$data['easing']=$this->easingType;
		$data['animation']=$this->animationType;

		$data['sort_type']=$this->sortType;
		$data['sort_direction']=$this->sortDirection;
		
		$data['category']=get_categories(array('hide_empty'=>0,'hierarchical'=>0));

		$data['custom_post_type']=array_diff_assoc(get_post_types(),array('attachment'=>'attachment','revision'=>'revision','nav_menu_item'=>'nav_menu_item'));

		$Template=new NPPluginTemplate($data,PLUGIN_NEXT_POST_TEMPLATE_PATH.'admin.php');
		echo $Template->output();		
	}
	
	/**************************************************************************/
	
	function adminSaveOptionPage()
	{
		$Notice=new NPPluginNotice();
		$Validation=new NPPluginValidation($Notice);
		
		$result=array();
		$response=array('global'=>array('error'=>1));
		
		$option=array();
		$optionDefault=$this->getFlatOptionArray();
		
		$invalidValue=__('Invalid value','next-post');
		
		/***/

		foreach($_POST as $key=>$value)
		{
			if(preg_match('/^'.PLUGIN_NEXT_POST_OPTION_GENERAL.'|'.PLUGIN_NEXT_POST_OPTION_PREV_POST.'|'.PLUGIN_NEXT_POST_OPTION_NEXT_POST.'/',$key,$result))
				$option[$key]=$value;
		}
		
		foreach($optionDefault as $optionIndex=>$optionValue)
		{
			if(!array_key_exists($optionIndex,$option)) $option[$optionIndex]='';
		}
		
		$option=stripslashes_deep($option);
		
		/***/

		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('enable')],0,1),array(NPPluginHelper::getFormNameGeneral('enable'),$invalidValue));
		if(!in_array($option[NPPluginHelper::getFormNameGeneral('sort_type')],array_keys($this->sortType)))
			$Notice->addError(NPPluginHelper::getFormNameGeneral('sort_type'),$invalidValue);
		if(!in_array($option[NPPluginHelper::getFormNameGeneral('sort_direction')],array_keys($this->sortDirection)))
			$Notice->addError(NPPluginHelper::getFormNameGeneral('sort_direction'),$invalidValue);
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('responsive_enable')],0,1),array(NPPluginHelper::getFormNameGeneral('responsive_enable'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('load_event_enable')],0,1),array(NPPluginHelper::getFormNameGeneral('load_event_enable'),$invalidValue));

		/***/
		
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('style_box_padding_top')],0,999,true),array(NPPluginHelper::getFormNameGeneral('style_box_padding_top'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('style_box_padding_right')],0,999,true),array(NPPluginHelper::getFormNameGeneral('style_box_padding_right'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('style_box_padding_bottom')],0,999,true),array(NPPluginHelper::getFormNameGeneral('style_box_padding_bottom'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('style_box_padding_left')],0,999,true),array(NPPluginHelper::getFormNameGeneral('style_box_padding_left'),$invalidValue));
		$Validation->notice('isHexColor',array($option[NPPluginHelper::getFormNameGeneral('style_box_border_top_color')],true),array(NPPluginHelper::getFormNameGeneral('style_box_border_top_color'),$invalidValue));
		$Validation->notice('isHexColor',array($option[NPPluginHelper::getFormNameGeneral('style_box_border_right_color')],true),array(NPPluginHelper::getFormNameGeneral('style_box_border_right_color'),$invalidValue));
		$Validation->notice('isHexColor',array($option[NPPluginHelper::getFormNameGeneral('style_box_border_bottom_color')],true),array(NPPluginHelper::getFormNameGeneral('style_box_border_bottom_color'),$invalidValue));
		$Validation->notice('isHexColor',array($option[NPPluginHelper::getFormNameGeneral('style_box_border_left_color')],true),array(NPPluginHelper::getFormNameGeneral('style_box_border_left_color'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('style_box_border_top_width')],0,999,true),array(NPPluginHelper::getFormNameGeneral('style_box_border_top_width'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('style_box_border_right_width')],0,999,true),array(NPPluginHelper::getFormNameGeneral('style_box_border_right_width'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('style_box_border_bottom_width')],0,999,true),array(NPPluginHelper::getFormNameGeneral('style_box_border_bottom_width'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('style_box_border_left_width')],0,999,true),array(NPPluginHelper::getFormNameGeneral('style_box_border_left_width'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('style_header_font_size')],0,999,true),array(NPPluginHelper::getFormNameGeneral('style_header_font_size'),$invalidValue));
		$Validation->notice('isHexColor',array($option[NPPluginHelper::getFormNameGeneral('style_header_font_color')],true),array(NPPluginHelper::getFormNameGeneral('style_header_font_color'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('style_title_font_size')],0,999,true),array(NPPluginHelper::getFormNameGeneral('style_title_font_size'),$invalidValue));
		$Validation->notice('isHexColor',array($option[NPPluginHelper::getFormNameGeneral('style_title_font_color')],true),array(NPPluginHelper::getFormNameGeneral('style_title_font_color'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameGeneral('style_content_font_size')],0,999,true),array(NPPluginHelper::getFormNameGeneral('style_content_font_size'),$invalidValue));
		$Validation->notice('isHexColor',array($option[NPPluginHelper::getFormNameGeneral('style_content_font_color')],true),array(NPPluginHelper::getFormNameGeneral('style_content_font_color'),$invalidValue));
			
		/***/

		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('enable')],0,1),array(NPPluginHelper::getFormNameNext('enable'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('display_image')],0,1,true),array(NPPluginHelper::getFormNameNext('display_image'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('display_title')],0,1,true),array(NPPluginHelper::getFormNameNext('display_title'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('display_excerpt')],0,1,true),array(NPPluginHelper::getFormNameNext('display_excerpt'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('display_content')],0,1,true),array(NPPluginHelper::getFormNameNext('display_content'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('display_close_button')],0,1,true),array(NPPluginHelper::getFormNameNext('display_close_button'),$invalidValue));
		if($option[NPPluginHelper::getFormNameNext('post_excerpt_no_limit')]==0)
			$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('post_excerpt_limit_value')],0,9999),array(NPPluginHelper::getFormNameNext('post_excerpt_limit_value'),$invalidValue));
		else $option[NPPluginHelper::getFormNameNext('post_excerpt_limit_value')]=0;
		
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('offset')],0,100),array(NPPluginHelper::getFormNameNext('offset'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('position_value')],0,100),array(NPPluginHelper::getFormNameNext('position_value'),$invalidValue));
		if(!in_array($option[NPPluginHelper::getFormNameNext('position_type')],array('top','bottom')))
			$Notice->addError(NPPluginHelper::getFormNameNext('position_type_top'),$invalidValue);
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('box_width')],1,9999),array(NPPluginHelper::getFormNameNext('box_width'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('image_size_width')],1,999),array(NPPluginHelper::getFormNameNext('image_size_width'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('image_size_height')],1,999),array(NPPluginHelper::getFormNameNext('image_size_height'),$invalidValue));

		if(!in_array($option[NPPluginHelper::getFormNameNext('animation_type')],$this->animationType))
			$Notice->addError(NPPluginHelper::getFormNameNext('animation_type'),$invalidValue);	
		if(!in_array($option[NPPluginHelper::getFormNameNext('animation_open_easing')],$this->easingType))
			$Notice->addError(NPPluginHelper::getFormNameNext('animation_open_easing'),$invalidValue);		
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('animation_open_speed')],0,10000),array(NPPluginHelper::getFormNameNext('animation_open_speed'),$invalidValue));
		if(!in_array($option[NPPluginHelper::getFormNameNext('animation_close_easing')],$this->easingType))
			$Notice->addError(NPPluginHelper::getFormNameNext('animation_close_easing'),$invalidValue);		
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('animation_close_speed')],0,10000),array(NPPluginHelper::getFormNameNext('animation_close_speed'),$invalidValue));

		if(is_array($option[NPPluginHelper::getFormNameNext('category')]))
		{
			if(count($option[NPPluginHelper::getFormNameNext('category')])==0)
				$Notice->addError(NPPluginHelper::getFormNameNext('category'),__('Specify at least one option','next-post'));
		}
		if(is_array($option[NPPluginHelper::getFormNameNext('custom_post_type')]))
		{
			if(count($option[NPPluginHelper::getFormNameNext('custom_post_type')])==0)
				$Notice->addError(NPPluginHelper::getFormNameNext('custom_post_type'),__('Specify at least one type of post','next-post'));
		}
		
		if(!in_array($option[NPPluginHelper::getFormNameNext('responsive_width_enable')],array(0,1)))
			$Notice->addError(NPPluginHelper::getFormNameNext('responsive_width_enable'),$invalidValue);
		else
		{
			if($option[NPPluginHelper::getFormNameNext('responsive_width_enable')]==1)
				$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('responsive_width_value')],0,9999),array(NPPluginHelper::getFormNameNext('responsive_width_value'),$invalidValue));
		}
		if(!in_array($option[NPPluginHelper::getFormNameNext('responsive_height_enable')],array(0,1)))
			$Notice->addError(NPPluginHelper::getFormNameNext('responsive_height_enable'),$invalidValue);
		else
		{
			if($option[NPPluginHelper::getFormNameNext('responsive_height_enable')]==1)
				$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNameNext('responsive_height_value')],0,9999),array(NPPluginHelper::getFormNameNext('responsive_height_value'),$invalidValue));
		}		
		
		/***/

		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('enable')],0,1),array(NPPluginHelper::getFormNamePrev('enable'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('display_image')],0,1,true),array(NPPluginHelper::getFormNamePrev('display_image'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('display_title')],0,1,true),array(NPPluginHelper::getFormNamePrev('display_title'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('display_excerpt')],0,1,true),array(NPPluginHelper::getFormNamePrev('display_excerpt'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('display_content')],0,1,true),array(NPPluginHelper::getFormNamePrev('display_content'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('display_close_button')],0,1,true),array(NPPluginHelper::getFormNamePrev('display_close_button'),$invalidValue));
		if($option[NPPluginHelper::getFormNamePrev('post_excerpt_no_limit')]==0)
			$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('post_excerpt_limit_value')],0,9999),array(NPPluginHelper::getFormNamePrev('post_excerpt_limit_value'),$invalidValue));
		else $option[NPPluginHelper::getFormNamePrev('post_excerpt_limit_value')]=0;
			
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('offset')],0,100),array(NPPluginHelper::getFormNamePrev('offset'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('position_value')],0,100),array(NPPluginHelper::getFormNamePrev('position_value'),$invalidValue));
		if(!in_array($option[NPPluginHelper::getFormNamePrev('position_type')],array('top','bottom')))
			$Notice->addError(NPPluginHelper::getFormNamePrev('position_type_top'),$invalidValue);
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('box_width')],1,9999),array(NPPluginHelper::getFormNamePrev('box_width'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('image_size_width')],1,999),array(NPPluginHelper::getFormNamePrev('image_size_width'),$invalidValue));
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('image_size_height')],1,999),array(NPPluginHelper::getFormNamePrev('image_size_height'),$invalidValue));

		if(!in_array($option[NPPluginHelper::getFormNamePrev('animation_type')],$this->animationType))
			$Notice->addError(NPPluginHelper::getFormNamePrev('animation_type'),$invalidValue);	
		if(!in_array($option[NPPluginHelper::getFormNamePrev('animation_open_easing')],$this->easingType))
			$Notice->addError(NPPluginHelper::getFormNamePrev('animation_open_easing'),$invalidValue);		
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('animation_open_speed')],0,10000),array(NPPluginHelper::getFormNamePrev('animation_open_speed'),$invalidValue));
		if(!in_array($option[NPPluginHelper::getFormNamePrev('animation_close_easing')],$this->easingType))
			$Notice->addError(NPPluginHelper::getFormNamePrev('animation_close_easing'),$invalidValue);		
		$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('animation_close_speed')],0,10000),array(NPPluginHelper::getFormNamePrev('animation_close_speed'),$invalidValue));

		if(is_array($option[NPPluginHelper::getFormNamePrev('category')]))
		{
			if(count($option[NPPluginHelper::getFormNamePrev('category')])==0)
				$Notice->addError(NPPluginHelper::getFormNamePrev('category'),__('Specify at least one option'));
		}
		if(is_array($option[NPPluginHelper::getFormNamePrev('custom_post_type')]))
		{
			if(count($option[NPPluginHelper::getFormNamePrev('custom_post_type')])==0)
				$Notice->addError(NPPluginHelper::getFormNamePrev('custom_post_type'),__('Specify at least one type of post'));	
		}
		
		if(!in_array($option[NPPluginHelper::getFormNamePrev('responsive_width_enable')],array(0,1)))
			$Notice->addError(NPPluginHelper::getFormNamePrev('responsive_width_enable'),$invalidValue);
		else
		{
			if($option[NPPluginHelper::getFormNamePrev('responsive_width_enable')]==1)
				$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('responsive_width_value')],0,9999),array(NPPluginHelper::getFormNamePrev('responsive_width_value'),$invalidValue));
		}
		if(!in_array($option[NPPluginHelper::getFormNamePrev('responsive_height_enable')],array(0,1)))
			$Notice->addError(NPPluginHelper::getFormNamePrev('responsive_height_enable'),$invalidValue);
		else
		{
			if($option[NPPluginHelper::getFormNamePrev('responsive_height_enable')]==1)
				$Validation->notice('isNumber',array($option[NPPluginHelper::getFormNamePrev('responsive_height_value')],0,9999),array(NPPluginHelper::getFormNamePrev('responsive_height_value'),$invalidValue));
		}	
		
		/***/

		if($Notice->isError())
		{
			$response['local']=$Notice->getError();
		}
		else
		{
			$response['global']['error']=0;
			update_option(PLUGIN_NEXT_POST_CONTEXT,$option);
		}

		$response['global']['notice']=$Notice->createHTML(PLUGIN_NEXT_POST_TEMPLATE_PATH.'notice.php');

		echo json_encode($response);
		exit;		
	}
	
	/**************************************************************************/
	
	function publicCreate()
	{
		if($this->getNextOption('enable')==1) $this->getNextPost();
		if($this->getPrevOption('enable')==1) $this->getPrevPost();

		if((is_null($this->nextPost)) && (is_null($this->prevPost))) return;
	
		$data['option']=$this->option;
		$Template=new NPPluginTemplate($data,PLUGIN_NEXT_POST_TEMPLATE_PATH.'script.php');
		echo $Template->output();
		
		echo '<style type="text/css">'.$this->createCSS().'</style>';

		if(!is_null($this->nextPost)) $this->publicShow(PLUGIN_NEXT_POST_TEMPLATE_PATH.'next-post.php',$this->getNextOption(),$this->nextPost);
		if(!is_null($this->prevPost)) $this->publicShow(PLUGIN_NEXT_POST_TEMPLATE_PATH.'prev-post.php',$this->getPrevOption(),$this->prevPost);
	}
	
	/**************************************************************************/
	
	function getNextPostFilter($where)
	{
		global $table_prefix;
		
		switch($this->getGeneralOption('sort_type'))
		{
			case 'ID'				:
				$where.=' and ('.$table_prefix.'posts.ID'.($this->getGeneralOption('sort_direction')=='desc' ? '>' : '<').$this->post->ID.')';
			break;
			case 'post_date'		:
				$where.=' and ('.$table_prefix.'posts.post_date'.($this->getGeneralOption('sort_direction')=='desc' ? '>' : '<').'\''.$this->post->post_date.'\''.')';				
			break;		
			case 'modified'			:
				$where.=' and ('.$table_prefix.'posts.post_modified'.($this->getGeneralOption('sort_direction')=='desc' ? '>' : '<').'\''.$this->post->post_modified.'\''.')';
			break;			
		}

		return($where);
	}
	
	/**************************************************************************/
	
	function getNextPost()
	{
		if($this->currentPostId==0) return;
		if(($postType=$this->checkPostType((array)$this->getNextOption('custom_post_type')))===false) return;
		if(($postCategory=$this->checkPostCategory((array)$this->getNextOption('category')))===false) return;

		add_filter('posts_where',array($this,'getNextPostFilter'));

		$argument=array('post_type'=>$postType,'category'=>$postCategory,'numberposts'=>1,'orderby'=>$this->getGeneralOption('sort_type'),'order'=>$this->getGeneralOption('sort_direction')=='desc' ? 'asc' : 'desc','suppress_filters'=>false);
		$post=get_posts($argument);	

		remove_filter('posts_where',array($this,'getNextPostFilter'));

		$this->nextPost=null;
		
		if(count($post)==1) $this->nextPost=$post[0];
	}
	
	/**************************************************************************/
	
	function getPrevPostFilter($where)
	{
		global $table_prefix;
		
		switch($this->getGeneralOption('sort_type'))
		{
			case 'ID'				:
				$where.=' and ('.$table_prefix.'posts.ID'.($this->getGeneralOption('sort_direction')=='desc' ? '<' : '>').$this->post->ID.')';
			break;
			case 'post_date'		:
				$where.=' and ('.$table_prefix.'posts.post_date'.($this->getGeneralOption('sort_direction')=='desc' ? '<' : '>').'\''.$this->post->post_date.'\''.')';				
			break;		
			case 'modified'			:
				$where.=' and ('.$table_prefix.'posts.post_modified'.($this->getGeneralOption('sort_direction')=='desc' ? '<' : '>').'\''.$this->post->post_modified.'\''.')';
			break;			
		}

		return($where);
	}

	/******************************************************************************/

	function getPrevPost()
	{
		if($this->currentPostId==0) return;
		if(($postType=$this->checkPostType((array)$this->getPrevOption('custom_post_type')))===false) return;
		if(($postCategory=$this->checkPostCategory((array)$this->getPrevOption('category')))===false) return;
		
		add_filter('posts_where',array($this,'getPrevPostFilter'));

		$argument=array('post_type'=>$postType,'category'=>$postCategory,'numberposts'=>1,'orderby'=>$this->getGeneralOption('sort_type'),'order'=>$this->getGeneralOption('sort_direction'),'suppress_filters'=>false);
		$post=get_posts($argument);	

		remove_filter('posts_where',array($this,'getPrevPostFilter'));

		$this->prevPost=null;
		
		if(count($post)==1) $this->prevPost=$post[0];
	}
	
	/**************************************************************************/
	
	function checkPostType($postType)
	{
		if(!in_array($this->currentPostType,$postType)) return(false);
		return($this->currentPostType);
	}
	
	/**************************************************************************/
	
	function checkPostCategory($postCategory)
	{
		if($this->currentPostType!='post') return(implode(',',$this->currentPostCategory));
		
		$postCategory=(array)$postCategory;
		
		if((!count(array_intersect($postCategory,$this->currentPostCategory))) && (!in_array(0,$postCategory))) return(false);

		return(implode(',',$postCategory));
	}
	
	/**************************************************************************/
	
	function publicShow($path,$option,$post)
	{
		$data=array();
	
		$Validation=new NPPluginValidation();
	
		$data['post']=$post;
		$data['option']=$option;
	
		$data['thumbnail']=null;
		
		if(has_post_thumbnail($post->ID))
		{
			if($option['display_image']==1)
				$data['thumbnail']=get_the_post_thumbnail($post->ID,array($data['option']['image_size_width'],$data['option']['image_size_height']));
		}
        
		if(($Validation->isEmpty($data['post']->post_excerpt)) && ($option['display_content']==1))
			$data['post']->post_excerpt=preg_replace('/<[^>]*>/s','',$post->post_content);
		
		if((int)$option['post_excerpt_no_limit']==0)
		{
			$word=explode(' ',$data['post']->post_excerpt);
			$data['post']->post_excerpt=implode(' ',array_slice($word,0,$option['post_excerpt_limit_value']));
		}
	
		$data['permalink']=get_permalink($post->ID);

		if($Validation->isEmpty($data['post']->post_excerpt)) $data['post']->post_excerpt=null;
		
		$Template=new NPPluginTemplate($data,$path);
		echo $Template->output();	
	}
	
	/**************************************************************************/
	
	function publicSetData()
	{
		if($this->currentPostId!=0) return;
		
		if((is_single(get_the_ID())) || (is_page(get_the_ID()))) 
		{
			$this->post=get_post(get_the_ID());
			$this->currentPostId=get_the_ID();	
			$this->currentPostType=get_post_type();
			$this->currentPostCategory=wp_get_post_categories(get_the_ID());
		}
	}
	
	/**************************************************************************/
	
	function getLibraryPath($prefix,$path)
	{
		$result=null;
		if(is_null($path)) return($result);
		
		if(preg_match('/^\/\//',$path,$result)) return($path);
		return($prefix.$path);
	}
	
	/**************************************************************************/
	
	function getFlatOptionArray()
	{
		$optionFlat=array();
		
		$optionKey=array_keys($this->optionDefault);
		
		foreach($optionKey as $optionKeyName)
		{
			foreach($this->optionDefault[$optionKeyName] as $optionName=>$optionValue)
				$optionFlat[$optionKeyName.'_'.$optionName]=$optionValue;
		}
		
		return($optionFlat);
	}
	
	/**************************************************************************/
	
	function getOption($prefix,$option=null)
	{
		if(is_null($this->option)) $this->option=get_option(PLUGIN_NEXT_POST_CONTEXT);
		if(is_null($option))
		{
			$result=null;
			$option=array();
			
			foreach($this->option as $index=>$value)
			{
				if(preg_match('/^'.$prefix.'/',$index,$result))
					$option[preg_replace('/'.$prefix.'_/','',$index)]=$value;
			}
			
			return($option);
		}
		
		return($this->option[$prefix.'_'.$option]);
	}
	
	/**************************************************************************/
	
	function getNextOption($option=null)
	{
		return($this->getOption(PLUGIN_NEXT_POST_OPTION_NEXT_POST,$option));
	}
	
	/**************************************************************************/
	
	function getPrevOption($option=null)
	{
		return($this->getOption(PLUGIN_NEXT_POST_OPTION_PREV_POST,$option));
	}
	
	/**************************************************************************/
	
	function getGeneralOption($option=null)
	{
		return($this->getOption(PLUGIN_NEXT_POST_OPTION_GENERAL,$option));
	}
	
	/**************************************************************************/
	
	function createCSS()
	{
		$CSS=new NPPluginCSS();
		
		$content=null;
		
		$content.=$CSS->create(array
		(
			'selector'=>array('.next-post>div'),
			'property'=>array
			(
				'margin-top'=>$this->getGeneralOption('style_box_padding_top'),
				'margin-right'=>$this->getGeneralOption('style_box_padding_right'),
				'margin-bottom'=>$this->getGeneralOption('style_box_padding_bottom'),
				'margin-left'=>$this->getGeneralOption('style_box_padding_left')
			)
		),true);

		$content.=$CSS->create(array
		(
			'selector'=>array('.next-post'),
			'property'=>array
			(
				'border-top-width'=>$this->getGeneralOption('style_box_border_top_width'),
				'border-right-width'=>$this->getGeneralOption('style_box_border_right_width'),
				'border-bottom-width'=>$this->getGeneralOption('style_box_border_bottom_width'),
				'border-left-width'=>$this->getGeneralOption('style_box_border_left_width'),
				'border-top-color'=>$this->getGeneralOption('style_box_border_top_color'),
				'border-right-color'=>$this->getGeneralOption('style_box_border_right_color'),
				'border-bottom-color'=>$this->getGeneralOption('style_box_border_bottom_color'),
				'border-left-color'=>$this->getGeneralOption('style_box_border_left_color')
			)
		),true);

		$content.=$CSS->create(array
		(
			'selector'=>array('.next-post>div h3.next-post-header'),
			'property'=>array
			(
				'color'=>$this->getGeneralOption('style_header_font_color'),
				'font-size'=>$this->getGeneralOption('style_header_font_size'),
				'font-family'=>$this->getGeneralOption('style_header_font_family'),
			)
		),true);

		$content.=$CSS->create(array
		(
			'selector'=>array('.next-post>div a.next-post-title','.next-post>div a.next-post-title:hover'),
			'property'=>array
			(
				'color'=>$this->getGeneralOption('style_title_font_color'),
				'font-size'=>$this->getGeneralOption('style_title_font_size'),
				'font-family'=>$this->getGeneralOption('style_title_font_family'),
			)
		),true);

		$content.=$CSS->create(array
		(
			'selector'=>array('.next-post>div p.next-post-excerpt'),
			'property'=>array
			(
				'color'=>$this->getGeneralOption('style_content_font_color'),
				'font-size'=>$this->getGeneralOption('style_content_font_size'),
				'font-family'=>$this->getGeneralOption('style_content_font_family'),
			)
		),true);

		return($content);
	}
	
	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/