		<div class="to to-to">

			<form name="to_form" id="to_form" method="POST" action="#">

				<div id="to_notice"></div> 

				<div class="to-header to-clear-fix">

					<div class="to-header-left">

						<div>
							<h3>QuanticaLabs</h3>
							<h6><?php esc_html_e('Plugin Options','next-post'); ?></h6>
						</div>

					</div>

					<div class="to-header-right">

						<div>
							<h3>Next Post Fly Box for WordPress</h3>
							<h6>Wordpress Plugin ver. <?php echo PLUGIN_NEXT_POST_VERSION; ?></h6>&nbsp;&nbsp;
							<a href="http://support.quanticalabs.com" target="_blank">Support Forum</a>
							<a href="https://1.envato.market/next-post-fly-box-for-wordpress" target="_blank">Plugin site</a>
						</div>

						<a href="http://quanticalabs.com" class="to-header-right-logo"></a>

					</div>

				</div>

				<div class="to-content to-clear-fix">

					<div class="to-content-left">

						<ul class="to-menu" id="to_menu">

							<li><a href="#<?php echo NPPluginHelper::getFormNameGeneral('main'); ?>"><?php esc_html_e('Main','next-post'); ?><span></span></a></li>
							<li><a href="#<?php echo NPPluginHelper::getFormNameGeneral('style'); ?>" class="to-menu-style"><?php esc_html_e('Styles','next-post'); ?><span></span></a></li>
							<li>
								<a href="#<?php echo PLUGIN_NEXT_POST_OPTION_GENERAL; ?>" class="to-menu-next"><?php esc_html_e('Next post','next-post'); ?><span></span></a>
								<ul>
									<li><a href="#<?php echo NPPluginHelper::getFormNameNext('general'); ?>"><?php esc_html_e('General','next-post'); ?></a></li>
									<li><a href="#<?php echo NPPluginHelper::getFormNameNext('element'); ?>"><?php esc_html_e('Elements','next-post'); ?></a></li>
									<li><a href="#<?php echo NPPluginHelper::getFormNameNext('dimension'); ?>"><?php esc_html_e('Dimensions','next-post'); ?></a></li>
									<li><a href="#<?php echo NPPluginHelper::getFormNameNext('animation'); ?>"><?php esc_html_e('Animations','next-post'); ?></a></li>
									<li><a href="#<?php echo NPPluginHelper::getFormNameNext('categories'); ?>"><?php esc_html_e('Categories','next-post'); ?></a></li>
									<li><a href="#<?php echo NPPluginHelper::getFormNameNext('custom_post_type'); ?>"><?php esc_html_e('Custom post types','next-post'); ?></a></li>
									<li><a href="#<?php echo NPPluginHelper::getFormNameNext('responsive'); ?>"><?php esc_html_e('Responsive mode','next-post'); ?></a></li>
								</ul>
							</li>
							<li>
								<a href="#<?php echo PLUGIN_NEXT_POST_OPTION_PREV_POST; ?>" class="to-menu-prev"><?php esc_html_e('Prev post','next-post'); ?><span></span></a>
								<ul>
									<li><a href="#<?php echo NPPluginHelper::getFormNamePrev('general'); ?>"><?php esc_html_e('General','next-post'); ?></a></li>
									<li><a href="#<?php echo NPPluginHelper::getFormNamePrev('element'); ?>"><?php esc_html_e('Elements','next-post'); ?></a></li>
									<li><a href="#<?php echo NPPluginHelper::getFormNamePrev('dimension'); ?>"><?php esc_html_e('Dimensions','next-post'); ?></a></li>
									<li><a href="#<?php echo NPPluginHelper::getFormNamePrev('animation'); ?>"><?php esc_html_e('Animations','next-post'); ?></a></li>
									<li><a href="#<?php echo NPPluginHelper::getFormNamePrev('categories'); ?>"><?php esc_html_e('Categories','next-post'); ?></a></li>
									<li><a href="#<?php echo NPPluginHelper::getFormNamePrev('custom_post_type'); ?>"><?php esc_html_e('Custom post types','next-post'); ?></a></li>
									<li><a href="#<?php echo NPPluginHelper::getFormNamePrev('responsive'); ?>"><?php esc_html_e('Responsive mode','next-post'); ?></a></li>
								</ul>
							</li>

						</ul>

					</div>

					<div class="to-content-right" id="to_panel">

						<div id="<?php echo NPPluginHelper::getFormNameGeneral('main'); ?>">

							<ul class="to-form-field-list">

								<li>
									<h5><?php esc_html_e('Enable plugin','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Enable or disable plugin.','next-post'); ?></span>
									<div class="to-radio-button">
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameGeneral('enable'); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('enable_1'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNameGeneral('enable')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameGeneral('enable_1'); ?>"><?php esc_html_e('Plugin enabled','next-post'); ?></label>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameGeneral('enable'); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('enable_0'); ?>" value="0" <?php echo ($this->data['option'][NPPluginHelper::getFormNameGeneral('enable')]==0 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameGeneral('enable_0'); ?>"><?php esc_html_e('Plugin disabled','next-post'); ?></label>
									</div>
								</li>
								<li>
									<h5><?php esc_html_e('Field of sorting','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Select field of sorting.','next-post'); ?></span>
									<div class="to-radio-button">
<?php
		$i=0;
		foreach($this->data['sort_type'] as $index=>$value)
		{
			$i++;
?>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameGeneral('sort_type'); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('sort_type_'.$i); ?>" value="<?php echo esc_html($index); ?>" <?php echo ($this->data['option'][NPPluginHelper::getFormNameGeneral('sort_type')]==$index ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameGeneral('sort_type_'.$i); ?>"><?php echo esc_html($value); ?></label>
<?php			
		}
?>
									</div>
								</li>
								<li>
									<h5><?php esc_html_e('Direction of sorting','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Select direction of sorting.','next-post'); ?></span>
									<div class="to-radio-button">
<?php
		$i=0;
		foreach($this->data['sort_direction'] as $index=>$value)
		{
			$i++;
?>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameGeneral('sort_direction'); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('sort_direction_'.$i); ?>" value="<?php echo esc_html($index); ?>" <?php echo ($this->data['option'][NPPluginHelper::getFormNameGeneral('sort_direction')]==$index ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameGeneral('sort_direction_'.$i); ?>"><?php echo esc_html($value); ?></label>
<?php			
		}
?>	
									</div>
								</li>
								<li>	
									<h5><?php esc_html_e('Responsive mode','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Enable or disable responsive mode.','next-post'); ?></span>
									<div class="to-radio-button">
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameGeneral('responsive_enable'); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('responsive_enable_1'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNameGeneral('responsive_enable')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameGeneral('responsive_enable_1'); ?>"><?php esc_html_e('Enable','next-post'); ?></label>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameGeneral('responsive_enable'); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('responsive_enable_0'); ?>" value="0" <?php echo ($this->data['option'][NPPluginHelper::getFormNameGeneral('responsive_enable')]==0 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameGeneral('responsive_enable_0'); ?>"><?php esc_html_e('Disable','next-post'); ?></label>
									</div>
								</li>
								<li>	
									<h5><?php esc_html_e('JS "load" event','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Enable or disable JavaScript "load" event fired on "window" object.','next-post'); ?></span>
									<div class="to-radio-button">
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameGeneral('load_event_enable'); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('load_event_enable_1'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNameGeneral('load_event_enable')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameGeneral('load_event_enable_1'); ?>"><?php esc_html_e('Enable','next-post'); ?></label>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameGeneral('load_event_enable'); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('load_event_enable_0'); ?>" value="0" <?php echo ($this->data['option'][NPPluginHelper::getFormNameGeneral('load_event_enable')]==0 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameGeneral('load_event_enable_0'); ?>"><?php esc_html_e('Disable','next-post'); ?></label>
									</div>
								</li>								
								
								

							</ul>

						</div>

						<div id="<?php echo NPPluginHelper::getFormNameGeneral('style'); ?>">

							<ul class="to-form-field-list">

								<li>
									<h5><?php esc_html_e('Box padding','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Box padding in order: top, right, bottom, left (in px) - integer number from the range 0-999.','next-post'); ?></span>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Top:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_box_padding_top')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_box_padding_top'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_box_padding_top'); ?>" maxlength="3"/>
									</div>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Right:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_box_padding_right')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_box_padding_right'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_box_padding_right'); ?>" maxlength="3"/>
									</div>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Bottom:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_box_padding_bottom')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_box_padding_bottom'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_box_padding_bottom'); ?>" maxlength="3"/>
									</div>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Left:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_box_padding_left')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_box_padding_left'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_box_padding_left'); ?>" maxlength="3"/>
									</div>
								</li>
								<li>
									<h5><?php esc_html_e('Box border colors','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Box border colors in order: top, right, bottom, left (in HEX).',PLUGIN_NEXT_POST_VERSION); ?></span>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Top:','next-post'); ?></span>
										<input type="text" class="to-color-picker" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_box_border_top_color')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_top_color'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_top_color'); ?>" maxlength="6"/>
									</div>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Right:','next-post'); ?></span>
										<input type="text" class="to-color-picker" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_box_border_right_color')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_right_color'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_right_color'); ?>" maxlength="6"/>
									</div>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Bottom:','next-post'); ?></span>
										<input type="text" class="to-color-picker" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_box_border_bottom_color')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_bottom_color'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_bottom_color'); ?>" maxlength="6"/>
									</div>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Left:','next-post'); ?></span>
										<input type="text" class="to-color-picker" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_box_border_left_color')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_left_color'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_left_color'); ?>" maxlength="6"/>
									</div>
								</li>
								<li>
									<h5><?php esc_html_e('Box border width','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Box border width in order: top, right, bottom, left (in px) - integer number from the range 0-999.','next-post'); ?></span>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Top:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_box_border_top_width')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_top_width'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_top_width'); ?>" maxlength="3"/>
									</div>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Right:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_box_border_right_width')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_right_width'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_right_width'); ?>" maxlength="3"/>
									</div>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Bottom:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_box_border_bottom_width')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_bottom_width'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_bottom_width'); ?>" maxlength="3"/>
									</div>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Left:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_box_border_left_width')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_left_width'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_box_border_left_width'); ?>" maxlength="3"/>
									</div>
								</li>									
								<li>
									<h5><?php esc_html_e('Header styles','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Header styles in order: font family, font size, text color.','next-post'); ?></span>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Font family:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_header_font_family')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_header_font_family'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_header_font_family'); ?>" maxlength="255"/>
									</div>	
									<div>
										<span class="to-legend-field"><?php esc_html_e('Font size (in px) - integer number from the range 0-999:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_header_font_size')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_header_font_size'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_header_font_size'); ?>" maxlength="3"/>
									</div>	
									<div>
										<span class="to-legend-field"><?php esc_html_e('Font color (in HEX):','next-post'); ?></span>
										<input type="text" class="to-color-picker" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_header_font_color')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_header_font_color'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_header_font_color'); ?>" maxlength="6"/>
									</div>	
								</li>
								<li>
									<h5><?php esc_html_e('Title styles','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Title styles in order: font family, font size, text color.','next-post'); ?></span>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Font family:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_title_font_family')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_title_font_family'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_title_font_family'); ?>" maxlength="255"/>
									</div>	
									<div>
										<span class="to-legend-field"><?php esc_html_e('Font size (in px) - integer number from the range 0-999:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_title_font_size')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_title_font_size'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_title_font_size'); ?>" maxlength="3"/>
									</div>	
									<div>
										<span class="to-legend-field"><?php esc_html_e('Font color (in HEX):','next-post'); ?></span>
										<input type="text" class="to-color-picker" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_title_font_color')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_title_font_color'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_title_font_color'); ?>" maxlength="6"/>
									</div>	
								</li>
								<li>
									<h5><?php esc_html_e('Content styles','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Content styles in order: font family, font size, text color.','next-post'); ?></span>
									<div>
										<span class="to-legend-field"><?php esc_html_e('Font family:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_content_font_family')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_content_font_family'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_content_font_family'); ?>" maxlength="255"/>
									</div>	
									<div>
										<span class="to-legend-field"><?php esc_html_e('Font size (in px) - integer number from the range 0-999:','next-post'); ?></span>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_content_font_size')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_content_font_size'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_content_font_size'); ?>" maxlength="3"/>
									</div>	
									<div>
										<span class="to-legend-field"><?php esc_html_e('Font color (in HEX):','next-post'); ?></span>
										<input type="text" class="to-color-picker" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameGeneral('style_content_font_color')]); ?>" id="<?php echo NPPluginHelper::getFormNameGeneral('style_content_font_color'); ?>" name="<?php echo NPPluginHelper::getFormNameGeneral('style_content_font_color'); ?>" maxlength="6"/>
									</div>	
								</li>

							</ul>

						</div>

						<div id="<?php echo NPPluginHelper::getFormNameNext('general'); ?>">

							<ul class="to-form-field-list">

								<li>
									<h5><?php esc_html_e('Enable next post','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Enable or disable next post.','next-post'); ?></span>
									<div class="to-radio-button">
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameNext('enable'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('enable_1'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('enable')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('enable_1'); ?>"><?php esc_html_e('Next post enabled','next-post'); ?></label>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameNext('enable'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('enable_0'); ?>" value="0" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('enable')]==0 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('enable_0'); ?>"><?php esc_html_e('Next post disabled','next-post'); ?></label>
									</div>
								</li>

							</ul>

						</div>

						<div id="<?php echo NPPluginHelper::getFormNameNext('element'); ?>">

							<ul class="to-form-field-list">

								<li>
									<h5><?php esc_html_e('Elements','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Elements displayed in the box.','next-post'); ?></span>
									<div class="to-checkbox-button">
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNameNext('display_image'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('display_image'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('display_image')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('display_image'); ?>"><?php esc_html_e('Image','next-post'); ?></label>
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNameNext('display_title'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('display_title'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('display_title')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('display_title'); ?>"><?php esc_html_e('Post title','next-post'); ?></label>
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNameNext('display_excerpt'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('display_excerpt'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('display_excerpt')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('display_excerpt'); ?>"><?php esc_html_e('Post excerpt','next-post'); ?></label>
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNameNext('display_content'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('display_content'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('display_content')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('display_content'); ?>"><?php esc_html_e('Post content (if excerpt is empty)','next-post'); ?></label>
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNameNext('display_close_button'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('display_close_button'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('display_close_button')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('display_close_button'); ?>"><?php esc_html_e('Close button','next-post'); ?></label>
									</div>								
								</li>
								<li>
									<h5><?php esc_html_e('Header','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Header of the box.','next-post'); ?></span>						
									<div>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameNext('header_text')]); ?>" id="<?php echo NPPluginHelper::getFormNameNext('header_text'); ?>" name="<?php echo NPPluginHelper::getFormNameNext('header_text'); ?>" maxlength="255"/>
									</div>
								</li>
								<li>
									<h5><?php esc_html_e('Post excerpt limit','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Limit the number of words - integer number from the range 0-9999.','next-post'); ?></span>						
									<div>
										<input type="text" value="<?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('post_excerpt_no_limit')]==1 ? '' : $this->data['option'][NPPluginHelper::getFormNameNext('post_excerpt_limit_value')]); ?>" id="<?php echo NPPluginHelper::getFormNameNext('post_excerpt_limit_value'); ?>" name="<?php echo NPPluginHelper::getFormNameNext('post_excerpt_limit_value'); ?>" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('post_excerpt_no_limit')]==1 ? 'readonly' : ''); ?> maxlength="4"/>
									</div>
									<div class="to-checkbox-button">
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNameNext('post_excerpt_no_limit'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('post_excerpt_no_limit'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('post_excerpt_no_limit')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('post_excerpt_no_limit'); ?>"><?php esc_html_e('No limit','next-post'); ?></label>
									</div>	
								</li>

							</ul>

						</div>	

						<div id="<?php echo NPPluginHelper::getFormNameNext('dimension'); ?>">

							<ul class="to-form-field-list">

								<li>
									<h5><?php esc_html_e('Show fly box based on another element visibility','next-post'); ?></h5>
									<span class="to-legend">
										<?php esc_html_e('Enter a valid jQuery selector of the element. Fly box will be shown when element will be visible.','next-post'); ?><br/>
										<?php esc_html_e('E.g: #comments - fly box is visible when comments section is visible.','next-post'); ?>
									</span>
									<div>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameNext('offset_element')]); ?>" id="<?php echo NPPluginHelper::getFormNameNext('offset_element'); ?>" name="<?php echo NPPluginHelper::getFormNameNext('offset_element'); ?>" maxlength="255"/>
									</div>
								</li>
								<li>
									<h5><?php esc_html_e('Show fly box based on scrollbar value','next-post'); ?></h5>
									<span class="to-legend">
										<?php esc_html_e('Percentage of the scrollbar value after which the box has to be displayed.','next-post'); ?><br/>
										<?php esc_html_e('This value is used only when jQuery selector of the element (from previous option) isn\'t specified.','next-post'); ?>
									</span>
									<div>
										<div id="<?php echo NPPluginHelper::getFormNameNext('offset_slider'); ?>"></div>
										<input type="text" name="<?php echo NPPluginHelper::getFormNameNext('offset'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('offset'); ?>" class="to-slider-range" readonly value="<?php echo (int)$this->data['option'][NPPluginHelper::getFormNameNext('offset')]; ?>"/>
									</div>
								</li>
								<li>
									<h5><?php esc_html_e('Box position','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Position of the box - in percent of the window.','next-post'); ?></span>
									<div>
										<div id="<?php echo NPPluginHelper::getFormNameNext('position_value_slider'); ?>"></div>
										<input type="text" name="<?php echo NPPluginHelper::getFormNameNext('position_value'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('position_value'); ?>" class="to-slider-range" readonly value="<?php echo (int)$this->data['option'][NPPluginHelper::getFormNameNext('position_value')]; ?>"/>
									</div>
									<div class="to-radio-button">
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameNext('position_type'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('position_type_top'); ?>" value="top" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('position_type')]=='top' ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('position_type_top'); ?>"><?php esc_html_e('From the top of the page'); ?></label>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameNext('position_type'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('position_type_bottom'); ?>" value="bottom" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('position_type')]=='bottom' ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('position_type_bottom'); ?>"><?php esc_html_e('From the bottom of the page'); ?></label>
									</div>
								</li>
								<li>	
									<h5><?php esc_html_e('Box width','next-post'); ?></h5>
									<span class="to-legend">
										<?php esc_html_e('Box width in px - integer number from the range 1-9999.','next-post'); ?><br/>
										<?php esc_html_e('This value will be overwritten if responsive mode is enabled.','next-post'); ?>
									</span>			
									<div>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameNext('box_width')]); ?>" id="<?php echo NPPluginHelper::getFormNameNext('box_width'); ?>" name="<?php echo NPPluginHelper::getFormNameNext('box_width'); ?>" maxlength="4"/>
									</div>
								</li>
								<li>	
									<h5><?php esc_html_e('Image size','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Image size (width x height) in px - integer number from the range 1-999.','next-post'); ?></span>
									<div>
										<label for="<?php echo NPPluginHelper::getFormNameNext('image_size_width'); ?>" class="to-infield"><?php esc_html_e('Image width in px','next-post'); ?></label>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameNext('image_size_width')]); ?>" id="<?php echo NPPluginHelper::getFormNameNext('image_size_width'); ?>" name="<?php echo NPPluginHelper::getFormNameNext('image_size_width'); ?>" maxlength="3"/>
									</div>							
									<div>
										<label for="<?php echo NPPluginHelper::getFormNameNext('image_size_height'); ?>" class="to-infield"><?php esc_html_e('Image height in px','next-post'); ?></label>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameNext('image_size_height')]); ?>" id="<?php echo NPPluginHelper::getFormNameNext('image_size_height'); ?>" name="<?php echo NPPluginHelper::getFormNameNext('image_size_height'); ?>" maxlength="3"/>
									</div>								
								</li>

							</ul>

						</div>

						<div id="<?php echo NPPluginHelper::getFormNameNext('animation'); ?>">

							<ul class="to-form-field-list">

								<li>	
									<h5><?php esc_html_e('Animation','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Animation type.','next-post'); ?></span>
									<div class="to-radio-button">
<?php
		$i=0;
		foreach($this->data['animation'] as $value)
		{
			$i++;
?>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameNext('animation_type'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('animation_type_'.$i); ?>" value="<?php echo esc_attr($value); ?>" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('animation_type')]==$value ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('animation_type_'.$i); ?>"><?php echo esc_html($value) ?></label>
										
<?php
		}
?>									
									</div>		
								</li>						
								<li>	
									<h5><?php esc_html_e('Easing method (open)','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Easing method of animation used when box is opening.','next-post'); ?></span>							
									<div>
										<select name="<?php echo NPPluginHelper::getFormNameNext('animation_open_easing'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('animation_open_easing'); ?>">
<?php
		foreach($this->data['easing'] as $value)
			echo '<option value="'.esc_attr($value).'" '.($this->data['option'][NPPluginHelper::getFormNameNext('animation_open_easing')]==$value ? 'selected' : '').'>'.esc_html($value).'</option>';
?>
										</select>
									</div>
								</li>
								<li>	
									<h5><?php esc_html_e('Animation speed (open)','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Speed of animation used when box is opening (in milliseconds).','next-post'); ?></span>	
									<div>
										<div id="<?php echo NPPluginHelper::getFormNameNext('animation_open_speed_slider'); ?>"></div>
										<input type="text" name="<?php echo NPPluginHelper::getFormNameNext('animation_open_speed'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('animation_open_speed'); ?>" class="to-slider-range" readonly value="<?php echo (int)$this->data['option'][NPPluginHelper::getFormNameNext('animation_open_speed')]; ?>"/>
										<input type="hidden" value="<?php echo esc_attr(json_encode(array('max'=>10000))); ?>" />
									</div>
								</li>
								<li>
									<h5><?php esc_html_e('Easing type (close)','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Easing method of animation used when box is closing.','next-post'); ?></span>								
									<div>
										<select name="<?php echo NPPluginHelper::getFormNameNext('animation_close_easing'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('animation_close_easing'); ?>">
<?php
		foreach($this->data['easing'] as $value)
			echo '<option value="'.esc_attr($value).'" '.($this->data['option'][NPPluginHelper::getFormNameNext('animation_close_easing')]==$value ? 'selected' : '').'>'.esc_html($value).'</option>';
?>
										</select>
									</div>
								</li>
								<li>	
									<h5><?php esc_html_e('Animation speed (close)','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Speed of animation used when box is closing (in milliseconds).','next-post'); ?></span>
									<div>
										<div id="<?php echo NPPluginHelper::getFormNameNext('animation_close_speed_slider'); ?>"></div>
										<input type="text" name="<?php echo NPPluginHelper::getFormNameNext('animation_close_speed'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('animation_close_speed'); ?>" class="to-slider-range" readonly value="<?php echo (int)$this->data['option'][NPPluginHelper::getFormNameNext('animation_close_speed')]; ?>"/>
										<input type="hidden" value="<?php echo esc_attr(json_encode(array('max'=>10000))); ?>" />
									</div>
								</li>

							</ul>

						</div>	

						<div id="<?php echo NPPluginHelper::getFormNameNext('categories'); ?>">

							<ul class="to-form-field-list">

								<li>	
									<h5><?php esc_html_e('Categories','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Select categories of posts in which box need to be displayed.','next-post'); ?></span>
									<div class="to-checkbox-button">
<?php
		$i=0;
		foreach($this->data['category'] as $value)
		{
			$i++;
?>
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNameNext('category[]'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('category_'.$i); ?>" value="<?php echo esc_attr($value->term_id); ?>" <?php echo (in_array($value->term_id,(array)$this->data['option'][NPPluginHelper::getFormNameNext('category')]) ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('category_'.$i); ?>"><?php echo esc_html($value->name) ?></label>									
<?php
		}
?>									
									</div>	
								</li>

							</ul>

						</div>

						<div id="<?php echo NPPluginHelper::getFormNameNext('custom_post_type'); ?>">

							<ul class="to-form-field-list">

								<li>	
									<h5><?php esc_html_e('Custom post types','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Select custom post types in which box need to be displayed.','next-post'); ?></span>
									<div class="to-checkbox-button">
<?php
		$i=0;
		foreach($this->data['custom_post_type'] as $index=>$value)
		{
			$i++;
?>
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNameNext('custom_post_type[]'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('custom_post_type_'.$i); ?>" value="<?php echo esc_html($index); ?>" <?php echo (in_array($index,(array)$this->data['option'][NPPluginHelper::getFormNameNext('custom_post_type')]) ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('custom_post_type_'.$i); ?>"><?php echo esc_html($value); ?></label>
<?php			
		}
?>
									</div>										
								</li>

							</ul>

						</div>

						<div id="<?php echo NPPluginHelper::getFormNameNext('responsive'); ?>">

							<ul class="to-form-field-list">

								<li>	
									<h5><?php esc_html_e('Disable next post box (based on window width)','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Disable/enable functionality of next post box when window width (in px) is lower/equal than selected size.','next-post'); ?></span>
									<div class="to-radio-button">
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameNext('responsive_width_enable'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('responsive_width_enable_0'); ?>" value="0" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('responsive_width_enable')]==0 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('responsive_width_enable_0'); ?>"><?php esc_html_e('Box is always enable','next-post'); ?></label>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameNext('responsive_width_enable'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('responsive_width_enable_1'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('responsive_width_enable')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('responsive_width_enable_1'); ?>"><?php esc_html_e('Box is disable when window width is lower/equal than:','next-post'); ?></label>
										<input type="text" class="to-radio-text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameNext('responsive_width_value')]); ?>" id="<?php echo NPPluginHelper::getFormNameNext('responsive_width_value'); ?>" name="<?php echo NPPluginHelper::getFormNameNext('responsive_width_value'); ?>" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('responsive_width_enable')]==0 ? 'readonly' : ''); ?> maxlength="4"/>
									</div>	
								</li>
								<li>	
									<h5><?php esc_html_e('Disable next post box (based on window height)','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Disable/enable functionality of next post box when window height (in px) is lower/equal than selected size.','next-post'); ?></span>
									<div class="to-radio-button">
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameNext('responsive_height_enable'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('responsive_height_enable_0'); ?>" value="0" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('responsive_height_enable')]==0 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('responsive_height_enable_0'); ?>"><?php esc_html_e('Box is always enable','next-post'); ?></label>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNameNext('responsive_height_enable'); ?>" id="<?php echo NPPluginHelper::getFormNameNext('responsive_height_enable_1'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('responsive_height_enable')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNameNext('responsive_height_enable_1'); ?>"><?php esc_html_e('Box is disable when window height is lower/equal than:','next-post'); ?></label>
										<input type="text" class="to-radio-text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNameNext('responsive_height_value')]); ?>" id="<?php echo NPPluginHelper::getFormNameNext('responsive_height_value'); ?>" name="<?php echo NPPluginHelper::getFormNameNext('responsive_height_value'); ?>"  <?php echo ($this->data['option'][NPPluginHelper::getFormNameNext('responsive_height_enable')]==0 ? 'readonly' : ''); ?> maxlength="4"/>
									</div>	
								</li>

							</ul>

						</div>

						<div id="<?php echo NPPluginHelper::getFormNamePrev('general'); ?>">

							<ul class="to-form-field-list">

								<li>
									<h5><?php esc_html_e('Enable previous post','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Enable or disable previous post.','next-post'); ?></span>
									<div class="to-radio-button">
										<input type="radio" name="<?php echo NPPluginHelper::getFormNamePrev('enable'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('enable_1'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('enable')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('enable_1'); ?>"><?php esc_html_e('Previous post enabled','next-post'); ?></label>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNamePrev('enable'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('enable_0'); ?>" value="0" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('enable')]==0 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('enable_0'); ?>"><?php esc_html_e('Previous post disabled','next-post'); ?></label>
									</div>
								</li>

							</ul>

						</div>

						<div id="<?php echo NPPluginHelper::getFormNamePrev('element'); ?>">

							<ul class="to-form-field-list">

								<li>
									<h5><?php esc_html_e('Elements','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Elements displayed in the box.','next-post'); ?></span>
									<div class="to-checkbox-button">
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNamePrev('display_image'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('display_image'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('display_image')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('display_image'); ?>"><?php esc_html_e('Image','next-post'); ?></label>
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNamePrev('display_title'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('display_title'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('display_title')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('display_title'); ?>"><?php esc_html_e('Post title','next-post'); ?></label>
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNamePrev('display_excerpt'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('display_excerpt'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('display_excerpt')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('display_excerpt'); ?>"><?php esc_html_e('Post excerpt','next-post'); ?></label>
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNamePrev('display_content'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('display_content'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('display_content')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('display_content'); ?>"><?php esc_html_e('Post content (if excerpt is empty)','next-post'); ?></label>
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNamePrev('display_close_button'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('display_close_button'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('display_close_button')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('display_close_button'); ?>"><?php esc_html_e('Close button','next-post'); ?></label>
									</div>								
								</li>
								<li>
									<h5><?php esc_html_e('Header','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Header of the box.','next-post'); ?></span>						
									<div>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNamePrev('header_text')]); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('header_text'); ?>" name="<?php echo NPPluginHelper::getFormNamePrev('header_text'); ?>" maxlength="255"/>
									</div>
								</li>
								<li>
									<h5><?php esc_html_e('Post excerpt limit','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Limit the number of words - integer number from the range 0-9999.','next-post'); ?></span>						
									<div>
										<input type="text" value="<?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('post_excerpt_no_limit')]==1 ? '' : $this->data['option'][NPPluginHelper::getFormNamePrev('post_excerpt_limit_value')]); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('post_excerpt_limit_value'); ?>" name="<?php echo NPPluginHelper::getFormNamePrev('post_excerpt_limit_value'); ?>" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('post_excerpt_no_limit')]==1 ? 'readonly' : ''); ?> maxlength="4"/>
									</div>
									<div class="to-checkbox-button">
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNamePrev('post_excerpt_no_limit'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('post_excerpt_no_limit'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('post_excerpt_no_limit')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('post_excerpt_no_limit'); ?>"><?php esc_html_e('No limit','next-post'); ?></label>
									</div>	
								</li>

							</ul>

						</div>	

						<div id="<?php echo NPPluginHelper::getFormNamePrev('dimension'); ?>">

							<ul class="to-form-field-list">

								<li>
									<h5><?php esc_html_e('Show fly box based on another element visibility','next-post'); ?></h5>
									<span class="to-legend">
										<?php esc_html_e('Enter a valid jQuery selector of the element. Fly box will be shown when element will be visible.','next-post'); ?><br/>
										<?php esc_html_e('E.g: #comments - fly box is visible when comments section is visible.','next-post'); ?>
									</span>
									<div>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNamePrev('offset_element')]); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('offset_element'); ?>" name="<?php echo NPPluginHelper::getFormNamePrev('offset_element'); ?>" maxlength="255"/>
									</div>
								</li>
								<li>
									<h5><?php esc_html_e('Show fly box based on scrollbar value','next-post'); ?></h5>
									<span class="to-legend">
										<?php esc_html_e('Percentage of the scrollbar value after which the box has to be displayed.','next-post'); ?><br/>
										<?php esc_html_e('This value is used only when jQuery selector of the element (from previous option) isn\'t specified.','next-post'); ?>
									</span>
									<div>
										<div id="<?php echo NPPluginHelper::getFormNamePrev('offset_slider'); ?>"></div>
										<input type="text" name="<?php echo NPPluginHelper::getFormNamePrev('offset'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('offset'); ?>" class="to-slider-range" readonly value="<?php echo (int)$this->data['option'][NPPluginHelper::getFormNamePrev('offset')]; ?>"/>
									</div>
								</li>
								<li>
									<h5><?php esc_html_e('Box position','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Position of the box - in percent of the window.','next-post'); ?></span>
									<div>
										<div id="<?php echo NPPluginHelper::getFormNamePrev('position_value_slider'); ?>"></div>
										<input type="text" name="<?php echo NPPluginHelper::getFormNamePrev('position_value'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('position_value'); ?>" class="to-slider-range" readonly value="<?php echo (int)$this->data['option'][NPPluginHelper::getFormNamePrev('position_value')]; ?>"/>
									</div>
									<div class="to-radio-button">
										<input type="radio" name="<?php echo NPPluginHelper::getFormNamePrev('position_type'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('position_type_top'); ?>" value="top" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('position_type')]=='top' ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('position_type_top'); ?>"><?php esc_html_e('From the top of the page','next-post'); ?></label>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNamePrev('position_type'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('position_type_bottom'); ?>" value="bottom" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('position_type')]=='bottom' ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('position_type_bottom'); ?>"><?php esc_html_e('From the bottom of the page','next-post'); ?></label>
									</div>
								</li>
								<li>	
									<h5><?php esc_html_e('Box width','next-post'); ?></h5>
									<span class="to-legend">
										<?php esc_html_e('Box width in px - integer number from the range 1-9999.','next-post'); ?><br/>
										<?php esc_html_e('This value will be overwritten if responsive mode is enabled.','next-post'); ?>
									</span>
									<div>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNamePrev('box_width')]); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('box_width'); ?>" name="<?php echo NPPluginHelper::getFormNamePrev('box_width'); ?>" maxlength="4"/>
									</div>
								</li>
								<li>	
									<h5><?php esc_html_e('Image size','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Image size (width x height) in px - integer number from the range 1-999.','next-post'); ?></span>
									<div>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('image_size_width'); ?>" class="to-infield"><?php esc_html_e('Image width in px','next-post'); ?></label>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNamePrev('image_size_width')]); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('image_size_width'); ?>" name="<?php echo NPPluginHelper::getFormNamePrev('image_size_width'); ?>" maxlength="3"/>
									</div>							
									<div>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('image_size_height'); ?>" class="to-infield"><?php esc_html_e('Image height in px','next-post'); ?></label>
										<input type="text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNamePrev('image_size_height')]); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('image_size_height'); ?>" name="<?php echo NPPluginHelper::getFormNamePrev('image_size_height'); ?>" maxlength="3"/>
									</div>								
								</li>

							</ul>

						</div>

						<div id="<?php echo NPPluginHelper::getFormNamePrev('animation'); ?>">

							<ul class="to-form-field-list">

								<li>	
									<h5><?php esc_html_e('Animation','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Animation type.','next-post'); ?></span>
									<div class="to-radio-button">
<?php
		$i=0;
		foreach($this->data['animation'] as $value)
		{
			$i++;
?>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNamePrev('animation_type'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('animation_type_'.$i); ?>" value="<?php echo esc_attr($value); ?>" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('animation_type')]==$value ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('animation_type_'.$i); ?>"><?php echo esc_html($value) ?></label>									
<?php
		}
?>									
									</div>		
								</li>						
								<li>	
									<h5><?php esc_html_e('Easing type (open)','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Easing method of animation used when box is opening.','next-post'); ?></span>							
									<div>
										<select name="<?php echo NPPluginHelper::getFormNamePrev('animation_open_easing'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('animation_open_easing'); ?>">
<?php
		foreach($this->data['easing'] as $value)
			echo '<option value="'.esc_attr($value).'" '.($this->data['option'][NPPluginHelper::getFormNamePrev('animation_open_easing')]==$value ? 'selected' : '').'>'.esc_html($value).'</option>';
?>
										</select>
									</div>
								</li>
								<li>	
									<h5><?php esc_html_e('Animation speed (open)','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Speed of animation used when box is opening (in milliseconds).','next-post'); ?></span>	
									<div>
										<div id="<?php echo NPPluginHelper::getFormNamePrev('animation_open_speed_slider'); ?>"></div>
										<input type="text" name="<?php echo NPPluginHelper::getFormNamePrev('animation_open_speed'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('animation_open_speed'); ?>" class="to-slider-range" readonly value="<?php echo (int)$this->data['option'][NPPluginHelper::getFormNamePrev('animation_open_speed')]; ?>"/>
										<input type="hidden" value="<?php echo esc_attr(json_encode(array('max'=>10000))); ?>" />
									</div>
								</li>
								<li>
									<h5><?php esc_html_e('Easing type (close)','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Easing method of animation used when box is closing.','next-post'); ?></span>								
									<div>
										<select name="<?php echo NPPluginHelper::getFormNamePrev('animation_close_easing'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('animation_close_easing'); ?>">
<?php
		foreach($this->data['easing'] as $value)
			echo '<option value="'.esc_attr($value).'" '.($this->data['option'][NPPluginHelper::getFormNamePrev('animation_close_easing')]==$value ? 'selected' : '').'>'.esc_html($value).'</option>';
?>
										</select>
									</div>
								</li>
								<li>	
									<h5><?php esc_html_e('Animation speed (close)','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Speed of animation used when box is closing (in milliseconds).','next-post'); ?></span>
									<div>
										<div id="<?php echo NPPluginHelper::getFormNamePrev('animation_close_speed_slider'); ?>"></div>
										<input type="text" name="<?php echo NPPluginHelper::getFormNamePrev('animation_close_speed'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('animation_close_speed'); ?>" class="to-slider-range" readonly value="<?php echo (int)$this->data['option'][NPPluginHelper::getFormNamePrev('animation_close_speed')]; ?>"/>
										<input type="hidden" value="<?php echo esc_attr(json_encode(array('max'=>10000))); ?>" />
									</div>
								</li>

							</ul>

						</div>	

						<div id="<?php echo NPPluginHelper::getFormNamePrev('categories'); ?>">

							<ul class="to-form-field-list">

								<li>	
									<h5><?php esc_html_e('Categories','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Select categories of posts in which box need to be displayed.','next-post'); ?></span>
									<div class="to-checkbox-button">
<?php
		$i=0;
		foreach($this->data['category'] as $value)
		{
			$i++;
?>
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNamePrev('category[]'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('category_'.$i); ?>" value="<?php echo esc_attr($value->term_id); ?>" <?php echo (in_array($value->term_id,(array)$this->data['option'][NPPluginHelper::getFormNamePrev('category')]) ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('category_'.$i); ?>"><?php echo esc_html($value->name) ?></label>									
<?php
		}
?>									
									</div>	
								</li>

							</ul>

						</div>	

						<div id="<?php echo NPPluginHelper::getFormNamePrev('custom_post_type'); ?>">

							<ul class="to-form-field-list">

								<li>	
									<h5><?php esc_html_e('Custom post types','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Select custom post types in which box need to be displayed.','next-post'); ?></span>
									<div class="to-checkbox-button">
<?php
		$i=0;
		foreach($this->data['custom_post_type'] as $index=>$value)
		{
			$i++;
?>
										<input type="checkbox" name="<?php echo NPPluginHelper::getFormNamePrev('custom_post_type[]'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('custom_post_type_'.$i); ?>" value="<?php echo esc_attr($index); ?>" <?php echo (in_array($index,(array)$this->data['option'][NPPluginHelper::getFormNamePrev('custom_post_type')]) ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('custom_post_type_'.$i); ?>"><?php echo esc_html($value); ?></label>
<?php			
		}
?>
									</div>	
								</li>

							</ul>

						</div>

						<div id="<?php echo NPPluginHelper::getFormNamePrev('responsive'); ?>">

							<ul class="to-form-field-list">

								<li>	
									<h5><?php esc_html_e('Disable next post box (based on window width)','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Disable/enable functionality of prev post box when window width (in px) is lower/equal than selected size.','next-post'); ?></span>
									<div class="to-radio-button">
										<input type="radio" name="<?php echo NPPluginHelper::getFormNamePrev('responsive_width_enable'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('responsive_width_enable_0'); ?>" value="0" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('responsive_width_enable')]==0 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('responsive_width_enable_0'); ?>"><?php esc_html_e('Box is always enable','next-post'); ?></label>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNamePrev('responsive_width_enable'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('responsive_width_enable_1'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('responsive_width_enable')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('responsive_width_enable_1'); ?>"><?php esc_html_e('Box is disable when window width is lower/equal than:','next-post'); ?></label>
										<input type="text" class="to-radio-text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNamePrev('responsive_width_value')]); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('responsive_width_value'); ?>" name="<?php echo NPPluginHelper::getFormNamePrev('responsive_width_value'); ?>" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('responsive_width_enable')]==0 ? 'readonly' : ''); ?> maxlength="4"/>
									</div>	
								</li>
								<li>	
									<h5><?php esc_html_e('Disable next post box (based on window height)','next-post'); ?></h5>
									<span class="to-legend"><?php esc_html_e('Disable/enable functionality of prev post box when window height (in px) is lower/equal than selected size.','next-post'); ?></span>
									<div class="to-radio-button">
										<input type="radio" name="<?php echo NPPluginHelper::getFormNamePrev('responsive_height_enable'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('responsive_height_enable_0'); ?>" value="0" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('responsive_height_enable')]==0 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('responsive_height_enable_0'); ?>"><?php esc_html_e('Box is always enable','next-post'); ?></label>
										<input type="radio" name="<?php echo NPPluginHelper::getFormNamePrev('responsive_height_enable'); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('responsive_height_enable_1'); ?>" value="1" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('responsive_height_enable')]==1 ? 'checked' : ''); ?>/>
										<label for="<?php echo NPPluginHelper::getFormNamePrev('responsive_height_enable_1'); ?>"><?php esc_html_e('Box is disable when window height is lower/equal than:','next-post'); ?></label>
										<input type="text" class="to-radio-text" value="<?php echo esc_attr($this->data['option'][NPPluginHelper::getFormNamePrev('responsive_height_value')]); ?>" id="<?php echo NPPluginHelper::getFormNamePrev('responsive_height_value'); ?>" name="<?php echo NPPluginHelper::getFormNamePrev('responsive_height_value'); ?>" <?php echo ($this->data['option'][NPPluginHelper::getFormNamePrev('responsive_height_enable')]==0 ? 'readonly' : ''); ?> maxlength="4"/>
									</div>	
								</li>

							</ul>

						</div>

					</div>

				</div>

				<div class="to-footer clear-fix">

					<div class="to-footer-left">

						<ul class="to-social-list">
							<li><a href="http://themeforest.net/user/QuanticaLabs?ref=quanticalabs" class="to-social-list-envato" title="Envato"></a></li>
							<li><a href="http://www.facebook.com/QuanticaLabs" class="to-social-list-facebook" title="Facebook"></a></li>
							<li><a href="https://twitter.com/quanticalabs" class="to-social-list-twitter" title="Twitter"></a></li>
							<li><a href="http://quanticalabs.tumblr.com/" class="to-social-list-tumblr" title="Tumblr"></a></li>
						</ul>

					</div>

					<div class="to-footer-right">
						<input class="to-button" type="submit" value="<?php esc_attr_e('Save changes','next-post'); ?>" name="Submit" id="Submit"/>
					</div>			

				</div>

				<input type="hidden" name="action" value="adminSaveOptionPage" />

				<script type="text/javascript">

					jQuery(document).ready(function($)
					{
						$('.to').themeOption();
						var optionElement=$('.to').themeOptionElement({init:true});
<?php
						$key=array(PLUGIN_NEXT_POST_OPTION_NEXT_POST,PLUGIN_NEXT_POST_OPTION_PREV_POST);

						foreach($key as $value)
						{
?>
							$('#<?php echo $value.'_post_excerpt_no_limit'; ?>').bind('change',function()
							{
								var object=$('#<?php echo $value.'_post_excerpt_limit_value'; ?>');
								if($(this).prop('checked')) object.val('').prop('readonly',true);
								else object.prop('readonly',false);
							});
							$('input[name="<?php echo $value.'_responsive_width_enable'; ?>"]').bind('change',function() 
							{
								var object=$('#<?php echo $value.'_responsive_width_value'; ?>');
								object.val('');
								if(parseInt($(this).val())===0) object.prop('readonly',true);
								else object.prop('readonly',false);
							});
							$('input[name="<?php echo $value.'_responsive_height_enable'; ?>"]').bind('change',function() 
							{
								var object=$('#<?php echo $value.'_responsive_height_value'; ?>');
								object.val('');
								if(parseInt($(this).val())===0) object.prop('readonly',true);
								else object.prop('readonly',false);
							});
							
							optionElement.createSlider('#<?php echo $value.'_offset_slider'; ?>',0,100,<?php echo (int)$this->data['option'][$value.'_offset']; ?>);
							optionElement.createSlider('#<?php echo $value.'_position_value_slider'; ?>',0,100,<?php echo (int)$this->data['option'][$value.'_position_value']; ?>);
							optionElement.createSlider('#<?php echo $value.'_animation_open_speed_slider'; ?>',0,10000,<?php echo (int)$this->data['option'][$value.'_animation_open_speed']; ?>);
							optionElement.createSlider('#<?php echo $value.'_animation_close_speed_slider'; ?>',0,10000,<?php echo (int)$this->data['option'][$value.'_animation_close_speed']; ?>);
<?php
						}
?>
					});

				</script>

			</form>
			
		</div>